﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.1.3 - spells
-- Meranannon - Discordia - Vol'jin (EU)
-- rev 1
----------------------------------------------------------------------------------------------------
local DF = DF_namespace
local _

local current=1
local nbSpells = 0
local nbIds=0

local currentForm = 0
local currentPA = 0
local ripFix =0

local DF_spellFunctions={}

function DF:reset_spells_list()
	nbSpells = getn(DF_config.spells)
	
	for i = 1,nbSpells do
		
		-- init variables
		DF_config.spells[i].abiOldTimeLeft=0
		DF_config.spells[i].abiStack=0
		DF_config.spells[i].abiDotIndex=0
		DF_config.spells[i].abiTimeLeft=0
		DF_config.spells[i].abiDuration=0
		DF_config.spells[i].abiAlphaPulse=0
		DF_config.spells[i].abiRotatePulse=0
		DF_config.spells[i].abiRotatePulseInc=1
		DF_config.spells[i].abiCD=0
		DF_config.spells[i].abiEnd=0
		DF_config.spells[i].abiStart=0
		DF_config.spells[i].abiFake=0
		DF_config.spells[i].abiLast=0
		DF_config.spells[i].abiAlert=false
		DF_config.spells[i].abiCDAlert=false
	end
		
end

-- initialisation liste
function DF:init_spells_list()
	
	nbSpells = getn(DF_config.spells)
	
	for i = 1,nbSpells do
		
		-- init variables
		DF_config.spells[i].abiOldTimeLeft=0
		DF_config.spells[i].abiStack=0
		DF_config.spells[i].abiDotIndex=0
		DF_config.spells[i].abiTimeLeft=0
		DF_config.spells[i].abiDuration=0
		DF_config.spells[i].abiAlphaPulse=0
		DF_config.spells[i].abiRotatePulse=0
		DF_config.spells[i].abiRotatePulseInc=1
		DF_config.spells[i].abiCD=0
		DF_config.spells[i].abiPower={}
		DF_config.spells[i].abiEnd=0
		DF_config.spells[i].abiStart=0
		DF_config.spells[i].abiIsaBuff=false
		DF_config.spells[i].abiFake=0
		DF_config.spells[i].abiLast=0
		DF_config.spells[i].abiAlert=false
		DF_config.spells[i].abiCDAlert=false
		DF_config.spells[i].abiSoundWarningOk=false
		
		if DF_config.spells[i].sType=="ComboPoint" then
			DF_config.spells[i].sType="Custom"
			DF_config.spells[i].icon=0
			DF_config.spells[i].timerbar=0
			DF_config.spells[i].FX_enable=true
			DF_config.spells[i].comboPoints=DF:options_returnNumber(DF_config.spells[i].spellIDs)
			DF_config.spells[i].spellIDs="0"
			DF_config.spells[i].abiUserText="ComboPoint"
		end
		
		if DF_config.spells[i].FX_customtexture and DF_config.spells[i].FX_customtexture~="" then
			DF_config.spells[i].FX_texture="Interface\\AddOns\\DroodFocus\\custom\\"..DF_config.spells[i].FX_customtexture
			DF_config.spells[i].FX_customtexture=""
		end

		if DF_config.spells[i].TimerLimit==nil then
			DF_config.spells[i].TimerLimit=0
		end
		if DF_config.spells[i].TimerLimitSens==nil then
			DF_config.spells[i].TimerLimitSens=1
		end
		
		if DF_config.spells[i].abiRdyMode==nil then
			DF_config.spells[i].abiRdyMode=false
		end

		if DF_config.spells[i].abiWarn==nil then
			DF_config.spells[i].abiWarn=0
		end
		
		if DF_config.spells[i].abiLastCd==nil then
			DF_config.spells[i].abiLastCd=0
		end
	
		if DF_config.spells[i].FX_OffMode==nil then
			DF_config.spells[i].FX_OffMode=1
		end

		if DF_config.spells[i].abiTalent==nil then
			DF_config.spells[i].abiTalent=0
		end

		if DF_config.spells[i].abiSoundWarning==nil then
			DF_config.spells[i].abiSoundWarning=0
		end
		
		if DF_config.spells[i].abiTextWarning==nil then
			DF_config.spells[i].abiTextWarning=false
		end		
		
		if DF_config.spells[i].abiSoundWarningFile==nil then
			DF_config.spells[i].abiSoundWarningFile=""
		end		

		if DF_config.spells[i].abiBuffWarning==nil then
			DF_config.spells[i].abiBuffWarning=false
		end		

		if DF_config.spells[i].abiVieLimite==nil then
			DF_config.spells[i].abiVieLimite=0
		end		
		if DF_config.spells[i].abiVieLimiteSens==nil then
			DF_config.spells[i].abiVieLimiteSens=1
		end				
		if DF_config.spells[i].abiActiveCond==nil then
			DF_config.spells[i].abiActiveCond=true
		end				

		-- corrections des ID erronées
		
		-- numero,cherche,replace
		--DF:SetupGoodSpellsID(i,"33876","33878")
		--DF:SetupGoodSpellsID(i,"62606","132402")
		--DF:SetupGoodSpellsID(i,"52610","127538")
		--DF:SetupGoodSpellsID(i,"77758","106830")
		--DF:SetupGoodSpellsID(i,"91565","102355")
		--DF:SetupGoodSpellsID(i,"50334","106952;106951")

		DF_config.spells[i][""]=nil

		DF:completeTable(DF_config.spells[i],DF.DefaultSpell,true)

		if DF_config.spells[i].sType=="Buff" then
			DF_config.spells[i].sType="BuffPlayer"
		end		
		if DF_config.spells[i].sType=="Debuff" then
			DF_config.spells[i].sType="DebuffTarget"
		end		
		
		temp = tonumber(DF_config.spells[i].abiInternalCD)
		if temp==nil then temp=0 end
		DF_config.spells[i].abiInternalCD=temp
		
		-- sauve les nom des debuffs
		if DF_config.spells[i].names==nil then
			DF_config.spells[i].names={}
		else
			DF_config.spells[i].names=table.wipe(DF_config.spells[i].names)
			DF_config.spells[i].names={}
		end

		if DF_config.spells[i].ids==nil then
			DF_config.spells[i].ids={}
		else
			DF_config.spells[i].ids=table.wipe(DF_config.spells[i].ids)
			DF_config.spells[i].ids={}
		end
		
		temp=DF:explode ( ";", DF_config.spells[i].spellIDs )

		nbIds = getn(temp)

		for ide = 1,nbIds do
			
			if temp[ide]==nil then temp[ide]=0 end
			
			DF_config.spells[i].ids[ide]=tonumber(temp[ide])
			
			if DF_config.spells[i].ids[ide] then
				DF_config.spells[i].names[ide] = GetSpellInfo(DF_config.spells[i].ids[ide])
			else
				DF_config.spells[i].names[ide] = nil
			end
			
			if DF_config.spells[i].names[ide] == nil then
				DF_config.spells[i].names[ide] =DF.locale["unknow"]
			end
			
		end
		
		DF_config.spells[i].abiSpelltext=DF_config.spells[i].names[1]
		DF_config.spells[i].abiSpellId=DF_config.spells[i].ids[1]
		DF_config.spells[i].abiSpellIdForCD=DF_config.spells[i].ids[1]
				
		DF_spellFunctions[i]={}
		DF_spellFunctions[i].func=nil
		
		if DF_config.spells[i].luaCode~="" then
			local text = string.trim(DF_config.spells[i].luaCode)

			local args=""
			.."local DF_abiNum="..tostring(i).."\n"
			
			local func = loadstring(args..text, "DroodFocusLuaCodeSpell"..tostring(i))
			DF_spellFunctions[i].func = func
		end	

	end
	
	current=1
	
end

function DF:spells_isInList(num)
	
	nbSpells = getn(DF_config.spells)
	
	for i = 1,nbSpells do
	
		if DF_config.spells[i].abiInternalCD>0 then
	
			local nbIds = getn(DF_config.spells[i].ids)
			
			for ide = 1,nbIds do
				
				if (DF_config.spells[i].ids[ide] and DF_config.spells[i].ids[ide]==num) then
				
					DF_config.spells[i].abiAlert=true
					DF_config.spells[i].abiCDAlert=true
					return DF_config.spells[i].abiSpellIdForCD,DF_config.spells[i].abiInternalCD
					
				end
					
			end
			
		end
		
	end
	
	return nil,-1
	
end

function DF:SetupGoodSpellsID(num,sFind,sReplace)
		
		-- vérifier occurence dans liste ID
		local temp=DF:explode ( ";", sFind )
		local nb = getn(temp)

		local spells=DF:explode ( ";", DF_config.spells[num].spellIDs )
		local nbIds = getn(spells)

		local doIt=false
		
		for ide = 1,nbIds do
			
			for i = 1,nb do
				
				if spells[ide]==temp[i] then
					doIt=true
				end
				
			end
		end
		
		-- si une occurence a été trouvé
		if doIt then
			
			-- la chaine original
			local final=DF_config.spells[num].spellIDs
	
			-- la compléter avec les ID supplémentaires
			local ajout=DF:explode ( ";", sReplace )
			local nbajout = getn(ajout)
			
			for ide = 1,nbajout do

				doIt=true
				for i = 1,nbIds do
					if spells[i]==ajout[ide] then
						doIt=false
					end
				end

				if doIt then
					-- màj de la chaine
					final=final..";"..ajout[ide]
				end
				
			end
			
			DF_config.spells[num].spellIDs=final
			
		end

end

--
function DF:spells_list()

	local it=0
	
	nbSpells = getn(DF_config.spells)
	
	-- anime
	for it = 1,nbSpells do

		DEFAULT_CHAT_FRAME:AddMessage(tostring(DF_config.spells[it].abiSpelltext).." - "..tostring(DF_config.spells[it].timerbar));

	end
	
end

-- gestion de l'animation
function DF:spells_update(elapsed,allSpells)

	local it=0
	local nbSpells = getn(DF_config.spells)
	
	currentForm = DF:currentForm()	
	currentPA = DF:spell_getPowerAttack()	
	
	for it = 1,nbSpells do

		-- màj temps restant
		DF_config.spells[it].abiTimeLeft=DF_config.spells[it].abiTimeLeft-elapsed
		if DF_config.spells[it].abiTimeLeft<0 then
			DF_config.spells[it].abiTimeLeft=0
			DF_config.spells[it].abiStart=0
			DF_config.spells[it].abiSoundWarningOk=false
		end

		if DF_config.spells[it].abiTimeLeft>0 and DF_config.spells[it].abiSoundWarning>0 and DF_config.spells[it].abiSoundWarningOk==false then
			
			if DF_config.spells[it].abiTimeLeft<DF_config.spells[it].abiSoundWarning then
				
				DF_config.spells[it].abiSoundWarningOk=true
				
				if DF_config.spells[it].abiSoundWarningFile then
					DF:sound_play(DF_config.spells[it].abiSoundWarningFile)	
				end
				
				if DF_config.spells[it].abiTextWarning then
					local name, empty, imgDebuff, empty, empty, empty, empty, empty, empty = GetSpellInfo(DF_config.spells[it].abiSpellIdForCD);
					if imgDebuff then
						DF:alert_activate("4",true,imgDebuff,name,DF.locale["FadeIn"]..tostring(DF_config.spells[it].abiSoundWarning).." sec.")
					end					
				end
				
			end
			
		end
				
		--check iCD
		debutCD,dureeCD=DF:cooldown_getCD(DF_config.spells[it].abiSpellIdForCD)
		restant = (debutCD+dureeCD)-DF.currentTime
		if restant<0 then restant=0	end
		
		warning = tonumber(DF_config.spells[it].abiWarn)

		if (tonumber(DF_config.spells[it].abiInternalCD)>0 or warning>0) then

			if restant<warning or restant==0 then

				local name, empty, imgDebuff, empty, empty, empty, empty, empty, empty = GetSpellInfo(DF_config.spells[it].abiSpellIdForCD);
				if imgDebuff then
					if DF_config.spells[it].abiUserText then
						name=DF_config.spells[it].abiUserText
					end
					if restant==0 then
						if DF_config.spells[it].abiCDAlert==true then
							DF:cooldown_activate(imgDebuff)
							DF_config.spells[it].abiCDAlert=false
						end
					else
						if DF_config.spells[it].abiAlert==true then
							DF:alert_activate("4",true,imgDebuff,name,DF.locale["rdyIn"]..tostring(warning).." sec.")
							DF_config.spells[it].abiAlert=false
						end
					end
				end			
				
			end
		end		
		
	end		
	
	if not DF:toggle_isEnable() and allSpells==false then return end
	
	for it = 1,nbSpells do	
			
		if DF:spell_check(it) or DF_config.spells[it].abiSpellId==0 then
			
			doIt=true
				
			if DF_config.spells[it].comboPoints>0 then
				
				nbc = DF.currentCombos
				nbr = DF_config.spells[it].comboPoints
				
				if not nbc or nbc==nil then nbc=0 end		
				if not nbr or nbr==nil then nbr=0 end		
			
				if nbc>0 and nbr>0 and nbc>=nbr then
					DF_config.spells[it].abiFake=2
				else
					doIt=false
					DF_config.spells[it].abiFake=0
				end
				
			end
	
			if DF_config.spells[it].FX_stack>0 and doIt then
				
				nbc = DF_config.spells[it].abiStack
				nbr = DF_config.spells[it].FX_stack
				
				if not nbc or nbc==nil then nbc=0 end		
				if not nbr or nbr==nil then nbr=0 end		
			
				if nbc>0 and nbr>0 and nbc>=nbr then
					DF_config.spells[it].abiFake=2
				else
					doIt=false
					DF_config.spells[it].abiFake=0
				end
				
			end
	
			if DF_spellFunctions[it].func and doIt then
	
				result = DF_spellFunctions[it].func()
				if result==true then
					DF_config.spells[it].abiFake=2
				else
					doIt=false
					DF_config.spells[it].abiFake=0
				end
			end

			if DF_config.spells[it].TimerLimit>0 then
				
				if DF_config.spells[it].TimerLimitSens==1 then

					if DF_config.spells[it].abiTimeLeft>DF_config.spells[it].TimerLimit then
						doIt=false
					end
				
				elseif DF_config.spells[it].TimerLimitSens==2 then
				
					if DF_config.spells[it].abiTimeLeft<=DF_config.spells[it].TimerLimit then
						doIt=false
					end
	
				end
				
			end

			if DF_config.spells[it].abiVieLimite>0 then

				local current = UnitHealth("target");		
				local maxi = UnitHealthMax("target");
				local percent =0
				if current and maxi then
					percent = math.ceil((current/maxi)*100)
				end
				
				if DF_config.spells[it].abiVieLimiteSens==1 then

					if percent>DF_config.spells[it].abiVieLimite then
						doIt=false
					end
				
				elseif DF_config.spells[it].abiVieLimiteSens==2 then
				
					if percent<=DF_config.spells[it].abiVieLimite then
						doIt=false
					end
	
				end		
				
			end

			DF_config.spells[it].abiActiveCond=doIt
			DF:spells_activate(it)
			
		else
			
			DF:spells_desactivate(it)
								
			if DF_spellFunctions[it].func then

				result = DF_spellFunctions[it].func()

			end			
			
		end
	
	end
	
end

function DF:spell_exist(idcheck,namecheck,cible,filtre,strong)
	
	local index=1
	local name,debuffType,unitCaster, spellId=nil
	
	while true do 
		
		local name, empty, empty, empty, debuffType, empty, empty, unitCaster, empty, empty, spellId = UnitAura(cible, index, filtre) 

		-- plus de nom la liste est finie
		if not name then
			return nil
		end

		-- l'id correspond on tient le sort
		if spellId==idcheck then
			return index
		end
		
		index=index+1
		
	end
	
end

function DF:spell_getPowerAttack()
	
	local base, posBuff, negBuff = UnitAttackPower("player")
	local mastery=GetCombatRating(26)/10000
	local puissance = base + posBuff + negBuff
	local final=puissance+(puissance*mastery)
	
	return final
	
end

function DF:clearAbiPower(numero,tid)

	if DF.abiPowers[tid] and DF.abiPowers[tid][numero] then
		DF.abiPowers[tid][numero]=0
	end
	
end


function DF:setAbiPower(numero,tid)

	if not DF.abiPowers[tid] then
		DF.abiPowers[tid]={}
	end
	DF.abiPowers[tid][numero]=currentPA

				
end

function DF:spell_check(num)

	local filter = nil
	local sType = nil
	local perso = nil
	local combo = nil
	local form = DF_config.spells[num].form
	local nbIds=0
	local debuffName = nil
	local thatOk = false
	local difference=0
	
	local targetID=nil
	local targetuse=nil
	
	local name=nil
	local count=nil
	local rank=nil
	local duration=nil
	local expirationTime=nil
	local timeLeft=nil
	local caster=nil
	local isPerso=false
	local lid=nil
	local index=nil
	local dotIndex,dotTime=nil

	local empty=nil	
	
	local isActive = false
	
	-- récupére infos du spell
	sType = DF_config.spells[num].sType
	perso = DF_config.spells[num].perso
	combo = DF_config.spells[num].combo	

	nbIds = getn(DF_config.spells[num].ids)
		
	if (combo) then DF:combo_set(0) end		

	if sType=="DebuffTarget" or sType=="DebuffPlayer" or sType=="DebuffFocus" or sType=="DebuffPet" then
		
		DF_config.spells[num].abiIsaBuff=false
		
		if (perso) then
			filter="HARMFUL|PLAYER"
		else
			filter="HARMFUL"
		end

		targetuse=""
		
		if sType=="DebuffTarget" then
			
			targetuse="playertarget"
			
		elseif sType=="DebuffPlayer" then
			
			targetuse="player"
			
		elseif sType=="DebuffFocus" then
			
			targetuse="focus"
			
		elseif sType=="DebuffPet" then
			
			targetuse="pet"
			
		end
		
		if targetuse=="" then return false end
		
		targetID=UnitGUID(targetuse)
		if not targetID then return false end
			
		-- c'est un debuff
		thatOk = false

		-- cherche les debuffs
		for ide = 1,nbIds do
			
			if (DF_config.spells[num].ids[ide]) then
				
				index = DF:spell_exist(DF_config.spells[num].ids[ide],nil,targetuse,filter,DF_config.spells[num].strongcheck)
			
				-- si présent
				if (index) then
					
						thatOk = true
				
						-- sauve les infos		
						name, empty, empty, count, empty, duration, expirationTime, caster, empty, empty, empty = UnitAura(targetuse, index, filter) 
						lid=DF_config.spells[num].ids[ide]									
				end
				
			end
			
		end

		-- si c'est ok
		if thatOk then

			-- indique si le debuff appartient au joueur
			if (caster=="player") then
				isPerso=true
			else
				isPerso=false
			end
		
			-- si c'est un sort non personnel ou personnel et qui vient du joueur
			if (not perso or (perso and isPerso)) then
				
				-- indique spell active
				isActive=true

				-- si on dispose d'une fin de debuff, on retranche l'heure courante pour obtenir le temps restant
				if (expirationTime ~= nil) then
	
					timeLeft = expirationTime - DF.currentTime
					
					if (timeLeft<0) then
						timeLeft=0;
					end
				
					-- le sort vient d'être posé
					if DF_config.spells[num].abiStart==0 and timeLeft>duration-1 then
					
						DF:icons_pulse(num)
						DF:sound_play(DF_config.spells[num].abiSound)	
					
						if tonumber(DF_config.spells[num].abiInternalCD)>0 then
							DF:cooldown_addCD(DF_config.spells[num].abiSpellIdForCD,DF.currentTime,tonumber(DF_config.spells[num].abiInternalCD))
						end		
						DF_config.spells[num].abiAlert=true
						DF_config.spells[num].abiCDAlert=true
						
					end
					
					difference = timeLeft - DF_config.spells[num].abiOldTimeLeft
										
					if (difference>0 and difference~=timeLeft and isPerso) then

						DF_config.spells[num].abiSoundWarningOk=false							
						DF:icons_pulse(num)								
						
						if DF_config.spells[num].abiSpellIdForCD==1079 then
						
							if difference<=4 then
								
								-- lambeau
								DF_config.spells[num].abiStack = DF_config.spells[num].abiStack + 1
								if DF_config.spells[num].abiStack>3 then
									DF_config.spells[num].abiStack=3
								end
								
							else
							
								-- refresh
								DF_config.spells[num].abiStack = 0
								
							end
							
						end
						
					end
					
					DF_config.spells[num].abiOldTimeLeft = timeLeft
					
				else
					
					timeLeft=0;
					
				end
				
				-- sauve données dans le tableau
				DF_config.spells[num].abiSpellId=lid
				DF_config.spells[num].abiSpellIdForCD=DF_config.spells[num].ids[1]		
				DF_config.spells[num].abiStart=expirationTime-duration
				DF_config.spells[num].abiEnd=expirationTime				
				if (count>0) then
					DF_config.spells[num].abiStack=count
				end
				DF_config.spells[num].abiTimeLeft = timeLeft
				DF_config.spells[num].abiDuration = duration
				DF_config.spells[num].abiRank = rank
					
				-- abilités a combo pour notre barre? et count valide?
				if (combo) then DF:combo_set(count) end							

			end
				
		end

	elseif sType=="BuffPlayer" or sType=="BuffTarget" or sType=="BuffFocus" or sType=="BuffPet" then
		
		DF_config.spells[num].abiIsaBuff=true
		
		if (perso) then
			filter="HELPFUL|PLAYER"
		else
			filter="HELPFUL"
		end

		targetuse=""
	
		if sType=="BuffPlayer" then
			
			targetuse="player"
			
		elseif sType=="BuffTarget" then
			
			targetuse="playertarget"
			
		elseif sType=="BuffFocus" then
			
			targetuse="focus"
			
		elseif sType=="BuffPet" then
			
			targetuse="pet"
			
		end

		if targetuse=="" then return false end

		targetID=UnitGUID(targetuse)
		if not targetID then return false end
			
		-- c'est un debuff
		thatOk = false

		-- cherche les debuffs
		for ide = 1,nbIds do
			
			if (DF_config.spells[num].ids[ide]) then
				
				index = DF:spell_exist(DF_config.spells[num].ids[ide],nil,targetuse,filter,DF_config.spells[num].strongcheck)
			
				-- si présent
				if (index) then
					
						thatOk = true
				
						-- sauve les infos		
						name, empty, empty, count, empty, duration, expirationTime, caster, empty, empty, empty = UnitAura(targetuse, index, filter) 
						lid=DF_config.spells[num].ids[ide]									
				end
				
			end
			
		end

		-- si c'est ok
		if thatOk then
			
			-- indique si le debuff appartient au joueur
			if (caster=="player") then
				isPerso=true
			else
				isPerso=false
			end
		
			-- si c'est un sort non personnel ou personnel et qui vient du joueur
			if (not perso or (perso and isPerso)) then
				
				-- indique spell active
				isActive=true
				
				-- si on dispose d'une fin de debuff, on retranche l'heure courante pour obtenir le temps restant
				if (expirationTime and expirationTime>0) then
										
					timeLeft = expirationTime - DF.currentTime
					
					if (timeLeft<0) then
						timeLeft=0;
					end
					
					-- le sort vient d'être posé
					if DF_config.spells[num].abiStart==0 and timeLeft>duration-1 then
						
						DF:icons_pulse(num)
						DF:sound_play(DF_config.spells[num].abiSound)	
						if tonumber(DF_config.spells[num].abiInternalCD)>0 then
							DF:cooldown_addCD(DF_config.spells[num].abiSpellIdForCD,DF.currentTime,tonumber(DF_config.spells[num].abiInternalCD))
						end		
						
						DF_config.spells[num].abiAlert=true
						DF_config.spells[num].abiCDAlert=true

						if DF_config.spells[num].abiLast>0 then
							
							abiLastCd=DF.currentTime-DF_config.spells[num].abiLast
							
							if abiLastCd<DF_config.spells[num].abiLastCd or DF_config.spells[num].abiLastCd==0 then
								DF_config.spells[num].abiLastCd=abiLastCd
							end
							
						end
					
						DF_config.spells[num].abiLast=DF.currentTime

						if DF_config.spells[num].abiBuffWarning and not DF_config.alert.showBuff then
							local name, empty, imgDebuff, empty, empty, empty, empty, empty, empty = GetSpellInfo(DF_config.spells[num].abiSpellIdForCD);
							if imgDebuff then
								DF:alert_activate("4",true,imgDebuff,name,DF.locale["BuffGain"])
							end										
						end
						
					end
					
					difference = timeLeft - DF_config.spells[num].abiOldTimeLeft
										
					if (difference>0 and difference~=timeLeft) then
						DF_config.spells[num].abiSoundWarningOk=false							
						DF:icons_pulse(num)								
					end
					
					DF_config.spells[num].abiOldTimeLeft = timeLeft					
					
				else
					
					timeLeft=200000;
					
				end
				
				-- sauve données dans le tableau
				DF_config.spells[num].abiSpellId=lid
				DF_config.spells[num].abiSpellIdForCD=DF_config.spells[num].ids[1]		
				DF_config.spells[num].abiStart=expirationTime-duration
				DF_config.spells[num].abiEnd=expirationTime				
				if (count>0) then
					DF_config.spells[num].abiStack=count
				end
				DF_config.spells[num].abiTimeLeft = timeLeft
				DF_config.spells[num].abiDuration = duration
				DF_config.spells[num].abiRank = rank
			
				-- abilités a combo pour notre barre? et count valide?
				if (combo) then DF:combo_set(count) end							

			end
			
		end
		
	elseif sType=="Custom" then	
		
		DF_config.spells[num].abiIsaBuff=false	
		
		if DF:form_goofForm(form,currentForm) then
		
			return true
			
		end
		return false
		
	else
	
		DF_config.spells[num].abiIsaBuff=false	
		return false
		
	end
	
	return isActive

end

function DF:spells_activate(numero)
	DF:icons_activate(numero)
end

function DF:spells_activateCond(numero,etat)
	DF_config.spells[numero].abiActiveCond=etat
end

function DF:spells_desactivate(numero)
	nbSpells = getn(DF_config.spells)

	if numero then

		DF_config.spells[numero].abiOldTimeLeft=0
		DF_config.spells[numero].abiStack=0
		DF_config.spells[numero].abiTimeLeft=0
		DF_config.spells[numero].abiDuration=0
		DF_config.spells[numero].abiAlphaPulse=0
		DF_config.spells[numero].abiRotatePulse=0
		DF_config.spells[numero].abiRotatePulseInc=1
		DF_config.spells[numero].abiCD=0
		DF_config.spells[numero].abiDotIndex=0
		DF_config.spells[numero].abiEnd=0
		if not DF.configmode then
			DF_config.spells[numero].abiFake=0
		end						
		DF:icons_desactivate(numero)
		
	else
		
		for numero = 1,nbSpells do
	
			DF_config.spells[numero].abiTimeLeft=0
			DF_config.spells[numero].abiOldTimeLeft=0
			DF_config.spells[numero].abiStack=0
			DF_config.spells[numero].abiEnd=0
			DF_config.spells[numero].abiDotIndex=0
			DF:icons_desactivate(numero)		
			
		end
		
	end
	
end

function DF:spells_list_reinit()
	DF.pause=true
	DF:init_spells_list()
	DF:cooldown_initTable()
	DF:icons_reinit()
	DF:timerbar_reinit()
	DF:init_ooc_frame()
	DF.pause=false
end

function DF:changeSpellsID(num,sFind,sReplace)

	local final=""

	local spells=DF:explode ( ";", DF_config.spells[num].spellIDs )
	local nbIds = getn(spells)

	if (strfind(DF_config.spells[num].spellIDs,sReplace)) then
	
		final=DF_config.spells[num].spellIDs
	
	else

		for ide = 1,nbIds do
			
				if (spells[ide]==sFind) then
					final=final..sReplace
					DEFAULT_CHAT_FRAME:AddMessage(DF.coolName.." - Replace SpellID("..sFind..") with ("..sReplace..")")
				else
					final=final..spells[ide]
				end
				
				if (ide~=nbIds) then
					final=final..";"
				end
				
		end
		
	end
	
	DF_config.spells[num].spellIDs=final

end
